% // Calculating Total Absorption for 13CO//
% ONLY C-18O
% Loading the cross-section data files for two isotopologures
load CO_1216_92_97.txt;
load CO_1218_92_97.txt;
load CO_1316_92_97.txt;
load CS_C17O.txt;
% Reading C16O data file and creating a wave# and Cross-section file: 
% SigmaC16O 
WN1 = CO_1216_92_97(:,2);
SC16O = CO_1216_92_97(:,4);
% Reading C18O data file and creating a wave# and Cross-section file:
% SigmaC18O
WN2 = CO_1218_92_97(:,2);
SC18O = CO_1218_92_97(:,4);
% Reading C17O data file and creating a wave# and Cross-section file: 
% SigmaC17O 
WN3 = CS_C17O(:,2);
SC17O = CS_C17O(:,3);
%Reading 13CO data file and creating a wave# and Cross-section file: 
%Sigma13CO 
WN4 = CO_1316_92_97(:,2);
S13CO = CO_1316_92_97(:,4);
% Beam Profile Function Input
% Fit Curve: f=y0+a/(1+((x-x0)/b)^2)
% Where: a=286.1213, b=1777.696, y0=-13.6190, x0=Target_wave_Length(TWL)
TWL = input('Input wave-number of synchrotron band=');
% Lower_wavelength_range=LWLR,Upper_wavelength_range=UWLR
LWLR=TWL-150;
UWLR=TWL+150;
% Beam_current=BC
% WLR=Wave length range
WLR = LWLR:0.01:UWLR;
BC=(-13.619)+(286.1213)./(1+((WLR-(TWL))./(1777.696)).^2);
% Io = Initial photon intensity
% Total area under the curve~1.25E6==5E14 photons/sec; Unit Area==4E8 p/s
Io = BC * 0.01 * 4E8;
% Picking-up data points from the master data file
SigC16O = zeros(100000, 1);
for i = 1:length(WN1)
    if (WN1(i)>LWLR)&&(WN1(i)<UWLR)
    SigC16O(i)=SC16O(i);
    end
end
SigC16O(SigC16O==0) = [];
SigmaC16O=SigC16O(:);
NumberC16O=numel(SigmaC16O); %Number of elements in SigmaC16O   

SigC18O = zeros(100000, 1);
for j = 1:length(WN1)
    if (WN1(j)>LWLR)&&(WN1(j)<UWLR)
    SigC18O(j)=SC18O(j);
    end
end
SigC18O(SigC18O==0) = [];
SigmaC18O=SigC18O(:);
NumberC18O=numel(SigmaC18O); %Number of elements in SigmaC18O   

 SigC17O = zeros(100000, 1);
for k = 1:length(WN3)
    if (WN3(k)>LWLR)&&(WN3(k)<UWLR)
        SigC17O(k)=SC17O(k);
    end
 end
 SigC17O(SigC17O==0) = [];
 SigmaC17O=SigC17O(:);
 NumberC17O=numel(SigmaC17O); %Number of elements in SigmaC17O

 Sig13CO = zeros(100000, 1);
for i = 1:length(WN1)
    if (WN1(i)>LWLR)&&(WN1(i)<UWLR)
    Sig13CO(i)=S13CO(i);
    end
end
Sig13CO(Sig13CO==0) = [];
Sigma13CO=Sig13CO(:);
Number13CO=numel(Sigma13CO); %Number of elements in SigmaC16O   

% Absorption calculation for C16O
% BC16O is 16O breadown from C16O
% CDCO = input('Input value of column density=');
CDCO = 1E17;
CDC16O=0.9952*CDCO;
BC16O = zeros(1000000, 1);
for i=1:NumberC16O
    IC16O(i)= Io(i)*(exp((-SigmaC16O(i))*(CDC16O)));
    BC16O(i) = Io(i)-IC16O(i);
end
Total16O = sum(BC16O);

% Absorption calculation for C18O
% BC18O is 18O breakdown in C18O

BC18O = zeros(1000000, 1);
for j=1:NumberC18O
    IC18O(j)= Io(j)*exp(((-SigmaC18O(j))*((CDC16O)./500)));
    BC18O(j) = Io(j)-IC18O(j);
end
Total18O = sum(BC18O);

% Absorption calculation for C17O
% BC17O is 17O breakdown in C17O

BC17O = zeros(1000000, 1);
for k=1:NumberC17O
    IC17O(k)= Io(k)*exp((-SigmaC17O(k))*(CDC16O)./2500);
    BC17O(k) = Io(k)-IC17O(k);
end
Total17O = sum(BC17O);

%Absorption calculation for 13CO
%B13CO is 13C breakdown in 13CO
CD13CO=0.9866*CDCO;
B13CO = zeros(1000000, 1);
for k=1:Number13CO
    I13CO(k)= Io(k)*exp((-Sigma13CO(k))*(CD13CO));
    B13CO(k) = Io(k)-I13CO(k);
end
Total13C = sum(B13CO);

% Sum-total atom numbers
Gtotal16O = Total16O + Total13C; %I have added the 13C part as when 13C16O is broken, equal no of 16O is generated
Gtotal18O = Total18O;
Gtotal17O = Total17O;
Gtotal12C = Total16O + Total18O + Total17O; % Same logic as above
Gtotal13C = Total13C;
%Frac16O = (Gtotal16O)./ (Gtotal16O + Gtotal18O + Gtotal17O);
%Frac18O = (Gtotal18O)./ (Gtotal16O + Gtotal18O + Gtotal17O);
%Frac17O = (Gtotal17O)./ (Gtotal16O + Gtotal18O + Gtotal17O);
%R18O = ((Frac18O))./(Frac16O);
%R17O = ((Frac17O))./(Frac16O);
R18O = (Gtotal18O)./(Gtotal16O) ;
R17O = (Gtotal17O)./(Gtotal16O) ;
R13C = (Gtotal13C)./(Gtotal12C) ;
R18Ostd = 0.0020052; % From literature
R17Ostd = 0.0003799; % From literature
R13Cstd = 0.0112372; % From literature
delta18O = (((R18O)./(R18Ostd))-1)*1000;
d18Oln = 1000*(log(1+((delta18O)./1000)));
delta17O = (((R17O)./(R17Ostd))-1)*1000;
d17Oln = 1000*(log(1+((delta17O)./1000)));
delta13C = (((R13C)./(R13Cstd))-1)*1000;
d13Cln = 1000*(log(1+((delta13C)./1000)));
Totalmol = ((Gtotal16O + Gtotal18O + Gtotal17O)*60*60*8)./2; % Total number of O2
Micromol = (Totalmol)/(6.023E17);
Slope = (d17Oln)./d18Oln;
d18Oln
d17Oln
d13Cln
Micromol
